#include <stdio.h>
#include <avr/io.h>
#include <avr/wdt.h>
#include "C:\WinAVRkk\kklibx\defines.h"


//=====================  board  =====================#
#define newboard            0
#define hzgboard            1
#define oldboard			0
#define m8board 			0
#define v3board 			0
#define spirelais			0
//=====================     pinout     ====================
#include <pinout32.h>
//=====================  Grundanwendungen  =====================
#define use_spi  			0
#define use_watchdog  		0	
#define use_1wire  			0
#define verbose_ds1820		0
#define use_twi  			0
#define timer_smh			0
//==========================  adc  ============================
#define ADCenable   1
#define ADCchannel 	5  //0-7
#define ADCpresc	6  //1-7 1=>2 2=>4 3=>8 4=16 5=>32 6=>64 7=>128
#define ADCint		0  //Interrupt
#define ADCintRef	1  //interne Referenz
//---------------------------------------------------------------
#define use_int2forIR    	0 
#define GADR    			8 // ADR der RC5-Fernbedienung muss ausgelesen werden
//------------------------ Schalter fr u8 bool1 ----------------------------
#define     schalter_FB_verbose		0
#define     Schalter_wdg_reset 		0
#define     schalterDisplayTimer   	2
#define     schalterWDG_Menu   		3
#define     schalterVolleMinute   	4
#define     schalterKomfortx   		5
#define     schalterProgrammstart	6
#define     schalterVolleSecunde   	7

//================================== =========================================


//================= includes =======================================
#include <stdlib.h>
#include <avr/interrupt.h>
#include <util/delay.h>
//#include <stdbool.h>
#include <avr/eeprom.h>
#if use_wdg
#include <avr/wdt.h>
#endif

#if use_twi 
//#include "C:\WinAVRkk\kklib\i2cmaster.h"//fleury
//#include "C:\WinAVRkk\kklib\twimaster.c"//fleury
#include "C:\WinAVRkk\kklibx\kk_twixx.c"
#endif


//===================  variablen ==================
volatile uint8_t bool1;
u8 ds1307gefunden;


#if use_mcp23s17A || use_spi 
#include "C:\WinAVRkk\kklib\kkspi.h"
#endif

//===================  Includes  ==================

#if use_lcd4bit || use_lcd74hc || use_twilcd72x	
#include	"C:\WinAVRkk\kklibx\kklcdxx.c"
#include	"C:\WinAVRkk\kklibx\kklcdxx.h"
#endif

//glcd
#if use_glcd
//#include "C:\WinAVRkk\kklib\kklcd.h"
#endif

#if glcd_spi
/*#include "C:\WinAVRkk\kklib\kklcd.h"
#include "C:\WinAVRkk\kklib\lc7981.h"
#include "C:\WinAVRkk\kklib\lc7981.c"
#include "C:\WinAVRkk\kklib\graphics.h"
#include "C:\WinAVRkk\kklib\graphics.c"
*/
#endif

#if use_lcdili
#include "C:\winAVRkk\kklibx\init_ili9225.h"
#include "C:\winAVRkk\kklibx\lib_glcd.h"
#include "C:\WinAVRkk\kklibx\kklcdxx.h"
//#define FONT_WIDTH	5
//#define FONT_HEIGHT	7
//#include "C:\WinAVRkk\kklib\font5x7.h"
//#include "ili9225.c"
//#include "guix.c"
#endif


#if use_1wire
#include "C:\WinAVRkk\kklib\ds1820.c"
//#include "ds1820x.c"
#endif



//============================= inits  =========================


#if ADCenable
#if ADCint
#include	<avr\interrupt.h>
volatile int ADC_value;
ISR (ADC_vec)
{ADC_value=ADC;
//lcd_goto(2,1);
//lcd_int(ADC_value);
}
#endif
void init_ADC()
{
//	ADMUX =0b11100001;//REFS1 REFS2 ADLAR MUX4 MUX3 MUX2 MUX1 MUX0 
ADMUX=0b00000000 | ADCchannel;
#if ADCintRef
ADMUX |= 128|64;
#endif

//	ADCSRA=0b11011101;//ADEN ADSC ADFR ADIF ADIE ADPS2 ADPS1 ADPS0
ADCSRA=0b10000000 | ADCpresc;
#if ADCint
ADCSRA |= 8 ;
#endif
// 	ADMUX=0xC1; 	// 0b11000001 Port, Referenzspannung und Auflsung
 //	A=0x85; 	// 0b10000101 Modus, Interrupt und Start
}
#endif

v u8 varpwm=10;
//----------------------------------------------------------------------
initPWM(){ DDRD = (1 << PD5 ); //ATMega16
    // Timer 1 einstellen
	//oc0A B3
	//oc0B B4
	//oc1A D5
	//oc1B D4
	//oc2A D7
	//oc2B D6
	
	// Modus 14:
    //    Fast PWM, Top von ICR1
    //     WGM13    WGM12   WGM11    WGM10
    //      1        1       1        0
    //    Timer Vorteiler: 1
    //     CS12     CS11    CS10
    //       0        0       1
    //  Steuerung des Ausgangsport: Set at BOTTOM, Clear at match
    //     COM1A1   COM1A0
    //       1        0
    TCCR1A = (1<<COM1A1) | (1<<WGM11);
    TCCR1B = (1<<WGM13) | (1<<WGM12) | (1<<CS10);

    ICR1 = 0x00FF;////  den Endwert (TOP) fr den Zhler setzen
    OCR1A = varpwm;0x00FF/15;    // der Compare Wert
}
//----------------------------------------------------------------------


void init_all(void)
{

init_led;



#ifdef tast1_pin
	#define tast1		(!gbi(PIN(tast1_port),tast1_pin))
	#define init_tast1  {cbi(DDR(tast1_port),tast1_pin);sbi(PORT(tast1_port),tast1_pin);}
init_tast1;
#endif
#ifdef tast2_pin
	#define tast2		(!gbi(PIN(tast2_port),tast2_pin))
	#define init_tast2  {cbi(DDR(tast2_port),tast2_pin);	sbi(PORT(tast2_port),tast2_pin);}
init_tast2;
#endif
#ifdef tast3_pin
	#define tast3		(!gbi(PIN(tast3_port),tast3_pin))
	#define init_tast3  {cbi(DDR(tast3_port),tast3_pin);	sbi(PORT(tast3_port),tast3_pin);}
init_tast3;
#endif


#ifdef out0_pin
sbi(DDR(out0_port),out0_pin);
#define out0_on  sbi(PORT(out0_port),out0_pin)
#define out0_off cbi(PORT(out0_port),out0_pin)
#endif

#ifdef out1_pin
sbi(DDR(out1_port),out1_pin);
#define out1_on  sbi(PORT(out1_port),out1_pin)
#define out1_off cbi(PORT(out1_port),out1_pin)
#endif

#ifdef out2_pin
sbi(DDR(out2_port),out2_pin);
#define out2_on  sbi(PORT(out2_port),out2_pin)
#define out2_off cbi(PORT(out2_port),out2_pin)
#endif
#ifdef out3_pin
sbi(DDR(out3_port),out3_pin);
#define out3_on  sbi(PORT(out3_port),out3_pin)
#define out3_off cbi(PORT(out3_port),out3_pin)
#endif
#ifdef out4_pin
sbi(DDR(out4_port),out4_pin);
#define out4_on  sbi(PORT(out4_port),out4_pin)
#define out4_off cbi(PORT(out4_port),out4_pin)
#endif
#ifdef out5_pin
sbi(DDR(out5_port),out5_pin);
#define out5_on  sbi(PORT(out5_port),out5_pin)
#define out5_off cbi(PORT(out5_port),out5_pin)
#endif
#ifdef out6_pin
sbi(DDR(out6_port),out6_pin);
#define out6_on  sbi(PORT(out6_port),out6_pin)
#define out6_off cbi(PORT(out6_port),out6_pin)
#endif
#ifdef out7_pin
sbi(DDR(out7_port),out7_pin);
#define out7_on  sbi(PORT(out7_port),out7_pin)
#define out7_off cbi(PORT(out7_port),out7_pin)
#endif
#ifdef out8_pin
sbi(DDR(out8_port),out8_pin);
#define out8_on  sbi(PORT(out8_port),out8_pin)
#define out8_off cbi(PORT(out8_port),out8_pin)
#endif
#ifdef out9_pin
sbi(DDR(out9_port),out9_pin);
#define out9_on  sbi(PORT(out9_port),out9_pin)
#define out9_off cbi(PORT(out9_port),out9_pin)
#endif
#ifdef out10_pin
sbi(DDR(out10_port),out10_pin);
#define out10_on  sbi(PORT(out10_port),out10_pin)
#define out10_off cbi(PORT(out10_port),out10_pin)
#endif

}



//+++++++++++++++++ timer smh +++++++++++++++++++++++++++++++++++
#define wdg_on {zl_sec_timer0=0;sbi(bool1,schalterWDG);}
#define wdg_reset {zl_sec_timer0=0;}
#define wdg_off {cbi(bool1,schalterWDG);}
#define wdg_Menu_on {zl_sec_wdg=0;sbi(bool1,schalterWDG_Menu);}
#define wdg_Menu_reset {zl_sec_wdg=0;zl_sec_timer0=0;}
#define wdg_Menu_off {cbi(bool1,schalterWDG_Menu);zl_sec_wdg=0;}
volatile uint16_t zl_sec_timer0;


v u8 display_timer=1,zl_sec_wdg , var_error;

#if timer_smh
#ifndef defzeit
#define defzeit
volatile uint8_t sec,min,hou,WDY,DAY,MON,YEA;
#endif


volatile u8 zl_timer0,LaufzeitH,ds1307korrektur;
ISR(TIMER0_OVF_vect)
{
zl_timer0++;
if(zl_timer0==takt_timer){//3,6mhz
sbi(bool1,schalterVolleSecunde);//lgi(1,10,gbi(bool1,schalterVolleSecunde));
if(!gbi(bool1,Schalter_wdg_reset)){wdt_reset();}
	zl_timer0=0;sec++;zl_sec_timer0++;////13=>55 sec
	if(sec==60){	sec=0;	min++;	sbi(bool1,schalterVolleMinute);
//	if (gbi(bool1,schalterWDG_Menu)||gbi(bool1,Schalter_wdg_reset)){
				zl_sec_wdg++;
				#if(defined(__AVR_ATmega644__)||defined(_AVR_IOM1284P_H_))
				if(zl_sec_wdg==3)asm("jmp Sprung");
				if(zl_sec_wdg>3)sbi(bool1,Schalter_wdg_reset);
				#endif
//wenn 	zl_sec_wdg	nicht zurckgesetzt wird, lst der wdg aus		
	}
	if(min==60){	min=0;  hou++;	LaufzeitH++;
	if(hou==24){	hou=0;	ds1307korrektur=0;}


//++++++++++++++ Korrektur + Umschaltung Sommer/Winterzeit ++++++++++++++++

if(hou==3 && ds1307gefunden==0 && ds1307korrektur==0){
#ifdef kk_ds1307_getAll_to_global_struct_zt
	kk_ds1307_getAll_to_global_struct_zt();
	if(MON==10 && DAY>24 && WDY==7 ){
	hou--;
	kk_ds1307_setTime(hou,min,sec);
	}
#endif

	if(MON==3 && DAY>24 && WDY==7  ){
	hou++;
#ifdef kk_ds1307_getAll_to_global_struct_zt
	kk_ds1307_setTime(hou,min,sec);
#endif
	}
	
ds1307korrektur=1;	
}
//--------------Korrektur + Umschaltung Sommer/Winterzeit ________________


	
	
	     
//	if(display_timer==1){lcd_goto(1,1);lcd_int2(hou);}
	}

//++++++++++++++ wdg ++++++++++++++++++
if(zl_sec_timer0>150 && gbi(bool1,Schalter_wdg_reset) ){
//errolevel
eeprom_write_byte(0x1FC,var_error);
zl_sec_timer0=0;
#if(defined(__AVR_ATmega644__)||defined(_AVR_IOM1284P_H_))
/*asm("jmp Sprung");*/asm("jmp 0");}
#endif
//-------------- wdg ------------------


//if(display_timer==1){lcd_goto(1,3);if(sec%2==0){lw(":");}else{lw(" ");}}
/*if(display_timer==1){
lcd_goto(1,1);
#if use_twilcd64
lcd_zeit_short();
//lcd_int2(zl_sec_timer0);
#else
#if use_glcd
#else
lcd_zeit_short();
//lcd_zeit(hou,min,sec);
#endif
#endif
}//*/
}//==14

}
#endif//timer_smh
#if(defined(__AVR_ATmega644__)||defined(_AVR_IOM1284P_H_))
void WDT_off(void)
{
cli();//__disable_interrupt();
wdt_reset();//__watchdog_reset();
/* Clear WDRF in MCUSR */
MCUSR &= ~(1<<WDRF);
/* Write logical one to WDCE and WDE */
/* Keep old prescaler setting to prevent unintentional time-out */
WDTCSR |= (1<<WDCE) | (1<<WDE);
/* Turn off WDT */
WDTCSR = 0x00;
sei();//__enable_interrupt();
}
#endif




