	
	#define GLUE(a, b)  a##b
	#define PORT(x)    GLUE(PORT, x)
	#define PIN(x)    GLUE(PIN, x)
	#define DDR(x)    GLUE(DDR, x)
	#define sbi(var, bit) (var|=1<<bit)//set
	#define cbi(var, bit) (var&=~(1<<bit))//clear
	#define tbi(var, bit) (var^=1<<bit)//toggle
	#define gbi(var, bit) (var>>bit&1)//get
	#define wait  _delay_ms(1000)
	#define wait10  {_delay_ms(3333);_delay_ms(3333);_delay_ms(3333);}
	#define u8  uint8_t
	#define u16 uint16_t
	#define v volatile

//----------------------------------------
#define led_tog (PORT(LEDPort) ^=1<<LED1)
#define led_on   PORT(LEDPort)|=1<<LED1
#define led_off   PORT(LEDPort)&=~(1<<LED1)
#define led_blink {led_tog;_delay_ms(300);led_tog;_delay_ms(300);led_tog;\
		_delay_ms(300);led_tog;_delay_ms(300);}
#define init_led sbi(DDR(LEDPort),LED1);led_blink;

#define mosi_on  sbi(PORT(mosi_port),mosi_pin)
#define mosi_off cbi(PORT(mosi_port),mosi_pin)
#define sck_on  sbi(PORT(sck_port),sck_pin)
#define sck_off cbi(PORT(sck_port),sck_pin)
#define miso		gbi(PIN(miso_port),miso_pin)
#define cs_on  sbi(PORT(cs_port),cs_pin)
#define cs_off cbi(PORT(cs_port),cs_pin)



//colors

#define TRANSPARENT  1
#define RED  	0xf800
#define GREEN	0x07e0
#define BLUE 	0x001f
#define WHITE	0xffff
#define BLACK	0x0000
#define YELLOW  0xFFE0
#define GRAY0   0xEF7D   		//��ɫ0 3165 00110 001011 00101
#define GRAY1   0x8410      	//��ɫ1      00000 000000 00000
#define GRAY2   0x4208      	//��ɫ2  1111111111011111


#define     RGB(r, g, b)                (((r & 0xF8) << 8) | ((g & 0xFC) << 3) | ((b & 0xF8) >> 3))
#define     NONE                        RGB(0x00, 0x04, 0x00)
//#define     BLACK                       RGB(0x00, 0x00, 0x00)
#define     DKGRAY                      RGB(0x40, 0x40, 0x40)
//#define     GRAY                        RGB(0x80, 0x80, 0x80)
#define     LTGRAY                      RGB(0xA0, 0xA0, 0xA0)
//#define     WHITE                       RGB(0xFF, 0xFF, 0xFF)
#define     DKRED                       RGB(0xdc, 0x14, 0x3c)
//#define     RED                         RGB(0xFF, 0x00, 0x00)
#define     ORANGE                       RGB(0xFF, 0x8c, 0x00)
#define     DKGREEN                     RGB(0x00, 0x70, 0x00)
//#define     GREEN                       RGB(0x00, 0x8F, 0x00)
#define     LTGREEN                     RGB(0x7f, 0xFF, 0x00)
#define     DKBLUE                      RGB(0x00, 0x00, 0x60)
//#define     BLUE                        RGB(0x10, 0x10, 0xFF)
#define     LTBLUE                      RGB(0x60, 0x60, 0xFF)
#define     DKYELLOW                    RGB(0xff, 0x8c, 0x00)
//#define     YELLOW                      RGB(0xFF, 0xFF, 0x00)
#define     LTYELLOW                    RGB(0xFF, 0xFF, 0x80)
#define     DKMAGENTA                   RGB(0x60, 0x00, 0x60)
#define     MAGENTA                     RGB(0xFF, 0x00, 0xFF)
#define     LTMAGENTA                   RGB(0xFF, 0x60, 0xFF)
#define     DKCYAN                      RGB(0x00, 0x60, 0x60)
#define     CYAN                        RGB(0x00, 0xB0, 0xB0)
#define     LTCYAN                      RGB(0x60, 0xFF, 0xFF)
#define     GOLD                        RGB(0x90, 0x90, 0x30)
/* GLCD RGB color definitions                                                 */
#define Black           0x0000      /*   0,   0,   0 */
#define Navy            0x000F      /*   0,   0, 128 */
#define DarkGreen       0x03E0      /*   0, 128,   0 */
#define DarkCyan        0x03EF      /*   0, 128, 128 */
#define Maroon          0x7800      /* 128,   0,   0 */
#define Purple          0x780F      /* 128,   0, 128 */
#define Olive           0x7BE0      /* 128, 128,   0 */
#define LightGrey       0xC618      /* 192, 192, 192 */
#define DarkGrey        0x7BEF      /* 128, 128, 128 */
#define Blue            0x001F      /*   0,   0, 255 */
#define Green           0x07E0      /*   0, 255,   0 */
#define Cyan            0x07FF      /*   0, 255, 255 */
#define Red             0xF800      /* 255,   0,   0 */
#define Magenta         0xF81F      /* 255,   0, 255 */
#define Yellow          0xFFE0      /* 255, 255, 0   */
#define White           0xFFFF      /* 255, 255, 255 */
#define no_bg               0x0001	    //No Color Back Ground
#define BLACK               0x0000
#define WHITE               0xFFFF
#define RED                 0x8000
#define GREEN               0x0400
#define BLUE                0x0010
#define YELLOW           	0xFFF0
#define CYAN                0x0410
#define MAGENTA             0x8010
#define BROWN               0xFC00
#define OLIVE	            0x8400

#define BRIGHT_RED          0xF800
#define BRIGHT_GREEN        0x07E0
#define BRIGHT_BLUE         0x001F
#define BRIGHT_YELLOW       0xFFE0
#define BRIGHT_CYAN         0x07FF
#define BRIGHT_MAGENTA    	0xF81F

#define LIGHT_GRAY          0x8410
#define DARK_GRAY         	0x4208
#define LIGHT_BLUE          0x841F
#define LIGHT_GREEN         0x87F0
#define LIGHT_CYAN          0x87FF
#define LIGHT_RED         	0xFC10
#define LIGHT_MAGENTA      	0xFC1F

#define GRAY0       	    0xE71C
#define GRAY1         	    0xC618
#define GRAY2             	0xA514
#define GRAY3             	0x630C
#define GRAY4            	0x4208
#define GRAY5	            0x2104
#define	GRAY6	          	0x3186	

#define	BLUE0	            0x1086	
#define	BLUE1       		0x3188 
#define	BLUE2          	    0x4314
#define BLUE3         	    0x861C	

#define	CYAN0	            0x3D34
#define	CYAN1               0x1DF7		

#define	GREEN0              0x0200	
#define	GREEN1              0x0208	

