//ili9320spi - 240x320 - 2.8"  k.kappis

//Pinbelegung tft => avr:
//gnd   =>  gnd
//3,3V++  => v++ 
//Reset => reset_tft_pin oder avr-reset
//sck   => sck	
//sdo   => mosi
//cs    => beliebiger cs-pin


//============================================ Benutzereingaben
#define sck_tft_register		B
#define sck_tft_pin				7
#define miso_tft_register		B
#define miso_tft_pin			6
#define mosi_tft_register		B
#define mosi_tft_pin			5
#define cs_tft_register			B
#define cs_tft_pin				4
#define reset_tft_register		B
#define reset_tft_pin			3
#define  hwspi  				1
//============================================

//////////////////////////////////
// x=240,y=0               x=240,y=320
//
//
//
//
//
//
// x=0,y=0                  x=0,y=320
//////////////////////////////////

//#include "AsciiLib.h"
//#include "AsciiLib.c"
#ifndef FONT1
#include "lib_fonts.h"
#endif
//======== Standard-defines =====================
#ifndef sbi
#define GLUE(a, b)  a##b
#define PORT(x)    GLUE(PORT, x)
#define PIN(x)    GLUE(PIN, x)
#define DDR(x)    GLUE(DDR, x)
#define sbi(var, bit) (var|=1<<bit)//set
#define cbi(var, bit) (var&=~(1<<bit))//clear
#define tbi(var, bit) (var^=1<<bit)//toggle
#define gbi(var, bit) (var>>bit&1)//get
#define wait  _delay_ms(1000)
#define u8  uint8_t
#define u16 uint16_t
#define v volatile
#endif

#define X_MAX_PIXEL	        240
#define Y_MAX_PIXEL	        320
#define maxxlcd X_MAX_PIXEL	        
#define maxylcd Y_MAX_PIXEL	
#define MAX_X X_MAX_PIXEL	        
#define MAX_Y Y_MAX_PIXEL	

#define lcd_write GUI_Text
#define xlcd_write PutChar

#define SPI_START   (0x70)              /* Start byte for SPI transfer        */
#define SPI_RD      (0x01)              /* WR bit 1 within start              */
#define SPI_WR      (0x00)              /* WR bit 0 within start              */
#define SPI_DATA    (0x02)              /* RS bit 1 within start byte         */
#define SPI_INDEX   (0x00)              /* RS bit 0 within start byte         */
#define adr_index  			0x70                                               
#define adr_command			0x72
#define null 				0

#define BLACK               0x0000
#define WHITE               0xFFFF
#define RED                 0x8000
#define GREEN               0x0400
#define BLUE                0x0010
#define YELLOW           	0xFFF0

u16 curposx,curposy;
u16 backcolor=BLACK, frontcolor=WHITE;
u8 f_width=8, f_height=16;
//============================================

#define sck_tft_on  sbi(PORT(sck_tft_register),sck_tft_pin)
#define sck_tft_off cbi(PORT(sck_tft_register),sck_tft_pin)
#define mosi_tft_on  sbi(PORT(mosi_tft_register),mosi_tft_pin)
#define mosi_tft_off cbi(PORT(mosi_tft_register),mosi_tft_pin)
#define reset_tft_on  sbi(PORT(reset_tft_register),reset_tft_pin)
#define reset_tft_off cbi(PORT(reset_tft_register),reset_tft_pin)
#define cs_tft_on  sbi(PORT(cs_tft_register),cs_tft_pin)
#define cs_tft_off cbi(PORT(cs_tft_register),cs_tft_pin)


#if hwspi
void spi_out(u8 x) {
SPDR=x;
while(!(SPSR & (1<<SPIF)));
}

u8 spi_in(u8 x) {
SPDR=x;
while(!(SPSR & (1<<SPIF)));
return(SPDR);
}

#else
void spi_out(u8 databyte) {
	  for(u8 i=8;i>0;i--){
	  mosi_tft_off;
	  if(databyte & 128)mosi_tft_on;
	  databyte <<=1;
	  sck_tft_on;
	  sck_tft_off;
	  }
}
#endif

unsigned char LPC17xx_SPI_SendRecvByte (unsigned char byte_s)
{SPDR=byte_s;
while(!(SPSR & (1<<SPIF)));
}

void spi_init(void){
sbi(DDR(cs_tft_register),cs_tft_pin);
sbi(DDR(sck_tft_register),sck_tft_pin);
sbi(DDR(mosi_tft_register),mosi_tft_pin);
cbi(DDR(miso_tft_register),miso_tft_pin);
sbi(DDR(reset_tft_register),reset_tft_pin);
cbi(PORT(reset_tft_register),reset_tft_pin);
#if hwspi
SPCR=(1<<SPE)|(1<<MSTR);
SPCR|=(1<<CPOL);// 
SPCR|=(1<<CPHA);//
SPSR = (1 << SPI2X);  // maximale Geschwindigkeit: F_CPU / 2 
#endif
reset_tft_on;
_delay_ms(50);
}


//======================================================================



void  lcd_write_index(u8 dat){
cs_tft_off;
spi_out(adr_index);
spi_out(null);
spi_out(dat);
cs_tft_on;
}

void  lcd_write_data(u16 dat){
cs_tft_off;
spi_out(adr_command);
spi_out(dat>>8);
spi_out(dat&0xff);
cs_tft_on;
}


void  lcd_write_reg(u8 index, u16 dat){
lcd_write_index(index);
lcd_write_data(dat);
}

/*******************************************************************************
* Function Name  : LCD_Write_Data_Start
* Description    : Start of data writing to the LCD controller
* Input          : None
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
__inline void LCD_Write_Data_Start(void) 
{
  LPC17xx_SPI_SendRecvByte(SPI_START | SPI_WR | SPI_DATA);    /* Write : RS = 1, RW = 0       */
}

/*******************************************************************************
* Function Name  : LCD_Write_Data_Only
* Description    : Data writing to the LCD controller
* Input          : - data: data to be written  
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
 void LCD_Write_Data_Only(uint16_t data) 
{
  LPC17xx_SPI_SendRecvByte((data >>   8));      /* Write D8..D15                */
  LPC17xx_SPI_SendRecvByte((data & 0xFF));      /* Write D0..D7                 */
}


void lcd_ili9320_init(void)
{
	unsigned short DeviceCode;
	
//	LCD_Configuration();
spi_init();
//ili_reset();

//	DeviceCode = LCD_ReadReg(0x0000);		/* Read ID	*/	
	/* Different driver IC initialization*/
//	if( DeviceCode == 0x9320 || DeviceCode == 0x9300 )
//	{
		lcd_write_reg(0x00,0x0000);
		lcd_write_reg(0x01,0x0100); /* Driver Output Contral */
		lcd_write_reg(0x02,0x0700); /* LCD Driver Waveform Contral */
		lcd_write_reg(0x03,0x1038); /* Set the scan mode */
		lcd_write_reg(0x04,0x0000); /* Scalling Contral */
		lcd_write_reg(0x08,0x0202); /* Display Contral 2 */
		lcd_write_reg(0x09,0x0000); /* Display Contral 3 */
		lcd_write_reg(0x0a,0x0000); /* Frame Cycle Contal */
		lcd_write_reg(0x0c,(1<<0)); /* Extern Display Interface Contral 1 */
		lcd_write_reg(0x0d,0x0000); /* Frame Maker Position */
		lcd_write_reg(0x0f,0x0000); /* Extern Display Interface Contral 2 */     
		_delay_ms(50); 
		lcd_write_reg(0x07,0x0101); /* Display Contral */
		_delay_ms(50);    
		lcd_write_reg(0x10,(1<<12)|(0<<8)|(1<<7)|(1<<6)|(0<<4)); /* Power Control 1 */
		lcd_write_reg(0x11,0x0007);                              /* Power Control 2 */
		lcd_write_reg(0x12,(1<<8)|(1<<4)|(0<<0));                /* Power Control 3 */
		lcd_write_reg(0x13,0x0b00);                              /* Power Control 4 */
		lcd_write_reg(0x29,0x0000);                              /* Power Control 7 */
		lcd_write_reg(0x2b,(1<<14)|(1<<4)); 
	
		lcd_write_reg(0x50,0);       /* Set X Start */
		lcd_write_reg(0x51,239);	    /* Set X End */
		lcd_write_reg(0x52,0);	    /* Set Y Start */
		lcd_write_reg(0x53,319);	    /* Set Y End */
		_delay_ms(50);

		lcd_write_reg(0x60,0x2700); /* Driver Output Control */
		lcd_write_reg(0x61,0x0001); /* Driver Output Control */
		lcd_write_reg(0x6a,0x0000); /* Vertical Srcoll Control */
		
		lcd_write_reg(0x80,0x0000); /* Display Position? Partial Display 1 */
		lcd_write_reg(0x81,0x0000); /* RAM Address Start? Partial Display 1 */
		lcd_write_reg(0x82,0x0000); /* RAM Address End-Partial Display 1 */
		lcd_write_reg(0x83,0x0000); /* Displsy Position? Partial Display 2 */
		lcd_write_reg(0x84,0x0000); /* RAM Address Start? Partial Display 2 */
		lcd_write_reg(0x85,0x0000); /* RAM Address End? Partial Display 2 */
		
		lcd_write_reg(0x90,(0<<7)|(16<<0)); /* Frame Cycle Contral */
		lcd_write_reg(0x92,0x0000);         /* Panel Interface Contral 2 */
		lcd_write_reg(0x93,0x0001);         /* Panel Interface Contral 3 */
		lcd_write_reg(0x95,0x0110);         /* Frame Cycle Contral */
		lcd_write_reg(0x97,(0<<8)); 
		lcd_write_reg(0x98,0x0000);         /* Frame Cycle Contral */    
		lcd_write_reg(0x07,0x0133); 
//	}		
    _delay_ms(100);   /* delay 50 ms */		
}


void Set_cursor(u16 X  ,u16 Y){
lcd_write_reg(0x20 , X);
 lcd_write_reg(0x21 , Y);
}
void lcd_set_pixel(u16 x1  , u16 Y1  ,u16 color ){
    Set_cursor(x1 , Y1);
   lcd_write_index(0x22);
   lcd_write_data(color);
}


static void LCD_SetCursor( uint16_t Xpos, uint16_t Ypos )
{
	/* 0x9320 */
	lcd_write_reg(0x0020, Xpos );     
	lcd_write_reg(0x0021, Ypos );           
}


/*******************************************************************************
* Function Name  : LCD_Clear
* Description    : Fill the screen as the specified color
* Input          : - Color: Screen Color
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
void LCD_Clear(uint16_t Color)
{
	uint32_t index=0;
	
	LCD_SetCursor(0,0); 

	lcd_write_index(0x0022);

 	cs_tft_off; 
	LCD_Write_Data_Start();

	for( index = 0; index < MAX_X * MAX_Y; index++ )
	{
		
		//fehler....
		LCD_Write_Data_Only(Color);
		LCD_Write_Data_Only(Color);
		LCD_Write_Data_Only(Color);
		LCD_Write_Data_Only(Color);
		LCD_Write_Data_Only(Color);
		LCD_Write_Data_Only(Color);
		LCD_Write_Data_Only(Color);
		//lcd_write_reg(0x0022,Color);
	}
	cs_tft_on;
}

/******************************************************************************
* Function Name  : LCD_BGR2RGB
* Description    : RRRRRGGGGGGBBBBB To BBBBBGGGGGGRRRRR
* Input          : - color: BRG Color value  
* Output         : None
* Return         : RGB Color value
* Attention		 : None
*******************************************************************************/
static uint16_t LCD_BGR2RGB(uint16_t color)
{
	uint16_t  r, g, b, rgb;
	
	b = ( color>>0 )  & 0x1f;
	g = ( color>>5 )  & 0x3f;
	r = ( color>>11 ) & 0x1f;
	
	rgb =  (b<<11) + (g<<5) + (r<<0);
	
	return( rgb );
}

/******************************************************************************
* Function Name  : LCD_GetPoint
* Description    : Get color value for the specified coordinates
* Input          : - Xpos: Row Coordinate
*                  - Xpos: Line Coordinate 
* Output         : None
* Return         : Screen Color
* Attention		 : None
*******************************************************************************/
uint16_t LCD_GetPoint(uint16_t Xpos,uint16_t Ypos)
{
	uint16_t dummy;
	
	LCD_SetCursor(Xpos,Ypos);

	lcd_write_index(0x0022);  
	
//	dummy = LCD_ReadData();   /* An empty read */
//	dummy = LCD_ReadData(); 

	return  LCD_BGR2RGB( dummy );
}

/******************************************************************************
* Function Name  : LCD_SetPoint
* Description    : Drawn at a specified point coordinates
* Input          : - Xpos: Row Coordinate
*                  - Ypos: Line Coordinate 
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
void LCD_SetPoint(uint16_t Xpos,uint16_t Ypos,uint16_t point)
{
	if( Xpos >= MAX_X || Ypos >= MAX_Y )
	{
		return;
	}
	LCD_SetCursor(Xpos,Ypos);
	lcd_write_reg(0x0022,point);
}

//###############################################################################
//+++++++++++++++++++++++++++++++++++++++++
void GUI_Text(uint8_t *str)
{
	uint8_t TempChar;
    do
    {
        TempChar = *str++;
        PutChar(TempChar);

            curposy =curposy+ f_width;

    }
    while ( *str != 0 );
}


u8 lcd_zeilen_versatz;

//++++++++++++++++++++++++++++++++++++++++++
void lcd_goto(char Zeile,char Spalte){


curposy=(Spalte-1)*(f_width);
curposx=X_MAX_PIXEL-(Zeile-1)*(f_height)-lcd_zeilen_versatz;
}
//##################################

#define Gui_DrawPoint LCD_SetPoint
u16 testx[16],testy[16];
uint8_t *ptr_font=f8x12;
u8 frame=0, vertikal_zeichnen, ascii_versatz=32;
u8 frame_vert_versatz;
//++++++++++++++++++++++++++++++++++++++++++
void PutChar( uint8_t ASCI)
{	uint16_t i, j;
    uint16_t  tmp_char;
//Fontheader auswerten 
//f_width= pgm_read_byte( &ptr_font[2]);
//f_height=pgm_read_byte( &ptr_font[3]);
//frame =pgm_read_byte( &ptr_font[4]);
//vertikal_zeichnen=pgm_read_byte( &ptr_font[5]);
//if (frame==1){f_width++;f_height+=2;}

u16 Xpos=curposx;
u16 Ypos=curposy;
if(frame){
	if(!vertikal_zeichnen)Xpos=curposx-1+f_height;

for(i=0;i<f_width +1;i++){Gui_DrawPoint( Xpos+f_height+1-frame_vert_versatz,Ypos+f_width-i-1, backcolor );}
for(i=0;i<f_width +1;i++){Gui_DrawPoint( Xpos-frame_vert_versatz , Ypos+f_width- i-1,      backcolor );}
for(i=0;i<f_height+1;i++){Gui_DrawPoint( Xpos+f_height-i+1-frame_vert_versatz,Ypos-1, backcolor );}
//pos 1nach unten:
Xpos++;//90Bildschirm sonst ypos++
}
Xpos=curposx+1;




if(vertikal_zeichnen){
//Gui_DrawPoint(20,20,BLACK);
        for( j=0; j<f_width; j++ ){
	
 //      tmp_char = buffer[i];
tmp_char = pgm_read_byte( &ptr_font[(ASCI-32)*f_width+j+7]);
//lcd_int3(tmp_char);lw(" ");
    for( i=0; i<f_height; i++ ){
            if( (tmp_char >>(f_height-1) - i) & 0x01 == 0x01 ){
                //Gui_DrawPoint( Xpos -i , Ypos -j , frontcolor );  // Character color 
                Gui_DrawPoint( Xpos +i , Ypos +j , frontcolor );  // Character color 
            }else{
			if(backcolor!=TRANSPARENT)
			//Gui_DrawPoint( Xpos - i, Ypos -j , backcolor );  // Background color 
			Gui_DrawPoint( Xpos + i, Ypos +j , backcolor );  // Background color 

            }
        }
    }
}else{
//Xpos=curposx+2-f_height;
/**/    for( i=0; i<f_height; i++ )
    {
//       tmp_char = buffer[i];
tmp_char = pgm_read_byte( &ptr_font[(ASCI-ascii_versatz)*f_height+i+7]);
//tmp_char = ( f8x12[(ASCI-ascii_versatz)*f_height+i+7]);
testx[i]=f8x12[7+i+(ASCI-ascii_versatz)*f_height];
testy[i]=7+i+(ASCI-ascii_versatz)*f_height;
//lcd_int3(tmp_char);lw(" ");

        for( j=0; j<f_width; j++ ){
            if( (tmp_char >>(f_width-1) - j) & 0x01 == 0x01 ){
 // Gui_DrawPoint( Xpos +i , Ypos -j , frontcolor );  // Character color 
    Gui_DrawPoint( Xpos -i , Ypos +j , frontcolor );  // Character color 
            }else{
      //  if(backcolor!=TRANSPARENT)Gui_DrawPoint( Xpos + i, Ypos -j , backcolor );  
if(backcolor!=TRANSPARENT)Gui_DrawPoint( Xpos - i, Ypos +j , backcolor );  // Background color 
            }
        }
    }
	}
}

//_---------------------------------------------------------------------
void selectfont(u8 abfr){
switch (abfr){
case (1):
ptr_font=f5x7;f_width=5; f_height=7;vertikal_zeichnen=1; frame=1;lcd_zeilen_versatz=8;
ascii_versatz=32,frame_vert_versatz=0;
break;
case (2):
ptr_font=f8x12;f_width=8; f_height=12;vertikal_zeichnen=0; frame=0;lcd_zeilen_versatz=2;
ascii_versatz=32,frame_vert_versatz=0;
break;
case (3):
ptr_font=f3x5;f_width=3; f_height=5;vertikal_zeichnen=0; frame=1;lcd_zeilen_versatz=0;
ascii_versatz=32,frame_vert_versatz=8;
break;
}
}



